%global _hardened_build 1
%global __provides_exclude_from ^(%{?python3_sitearch:%{python3_sitearch}/.*\\.so})$

%global open_iscsi_version	2.1.9
%global commit0				a65a472a35b436c7a2d47c5862aae530ac4ae9c8
%global shortcommit0		%(c=%{commit0}; echo ${c:0:7})

%undefine _ld_as_needed

Summary:		iSCSI daemon and utility programs
Name:			iscsi-initiator-utils
Version:		6.%{open_iscsi_version}
Release:		1.git%{shortcommit0}%{?dist}
License:		LGPL-2.1-or-later
URL:			https://github.com/open-iscsi/open-iscsi
Source0:		https://github.com/open-iscsi/open-iscsi/archive/%{commit0}.tar.gz#/open-iscsi-%{shortcommit0}.tar.gz
Source1:		04-iscsi
Source2:		iscsi-tmpfiles.conf

Patch3000:      0001-meson-don-t-hide-things-with-Wno-all.patch
Patch3001:      0002-Currently-when-iscsi.service-is-installed-it-creates.patch
Patch3002:      0003-Use-DBROOT-in-iscsi-starter.-Include-iscsi-starter-i.patch
Patch3003:      0004-fix-systemctl-path-in-iscsi-starter.service.patch
Patch3004:      0005-improved-onboot-and-shutdown-services.patch
Patch3005:      0006-iscsid.conf-Fedora-Red-Hat-defaults.patch
Patch3006:      0007-Disable-Data-Digests.patch
Patch3007:      0008-Revert-iscsiadm-return-error-when-login-fails.patch
Patch3008:      0009-Coverity-scan-fixes.patch
Patch3009:      0010-use-Red-Hat-version-string-to-match-RPM-package-vers.patch
Patch3010:      0101-libiscsi.patch
Patch3011:      0102-libiscsi-introduce-sessions-API.patch
Patch3012:      0103-fix-libiscsi-firmware-discovery-issue-with-NULL-drec.patch
Patch3013:      0104-libiscsi-build-fixes.patch

Patch5000:      5000-Get-builddir-from-rpm-macro-_vpath_builddir.patch

BuildRequires:	flex bison doxygen systemd-units make autoconf automake libtool
BuildRequires:  meson git
BuildRequires:	isns-utils-devel systemd-devel libmount-devel openssl-devel
BuildRequires:  python3-devel python3-setuptools kmod-devel
Requires:		%{name}-iscsiuio >= %{version}-%{release}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary:		Userspace configuration daemon required for some iSCSI hardware
License:		BSD
Requires:		%{name} = %{version}-%{release}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary:		Development files for %{name}
Requires:		%{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package -n python3-%{name}
Summary:		Python 3 bindings to %{name}
Requires:		%{name} = %{version}-%{release}

%description -n python3-%{name}
The %{name}-python3 package contains Python %{python3_version} bindings to the
libiscsi interface for interacting with %{name}

%prep
%autosetup -p1 -n open-iscsi-%{commit0}

%build
%meson -Diqn_prefix=iqn.2023-01.org.opencloudos
%meson_build

%make_build iqn_prefix=iqn.2023-01.org.opencloudos DBROOT=/var/lib/iscsi libiscsi

pushd libiscsi
%py3_build
touch -r libiscsi.doxy html/*
popd

%install
%meson_install

install -d %{buildroot}%{_sharedstatedir}/iscsi
install -d %{buildroot}%{_sharedstatedir}/iscsi/nodes
install -d %{buildroot}%{_sharedstatedir}/iscsi/send_targets
install -d %{buildroot}%{_sharedstatedir}/iscsi/static
install -d %{buildroot}%{_sharedstatedir}/iscsi/isns
install -d %{buildroot}%{_sharedstatedir}/iscsi/slp
install -d %{buildroot}%{_sharedstatedir}/iscsi/ifaces

install -d %{buildroot}%{_rundir}/lock/iscsi
touch %{buildroot}%{_rundir}/lock/iscsi/lock

rm -f $RPM_BUILD_ROOT/etc/iscsi/initiatorname.iscsi
rm -f $RPM_BUILD_ROOT/etc/udev/rules.d/50-iscsi-firmware-login.rules
rm -f $RPM_BUILD_ROOT/usr/lib/systemd/system-generators/ibft-rule-generator
rm -f $RPM_BUILD_ROOT/usr/sbin/brcm_iscsiuio
rm -f $RPM_BUILD_ROOT/usr/sbin/iscsi-gen-initiatorname
rm -f $RPM_BUILD_ROOT/usr/sbin/iscsi_discovery
rm -f $RPM_BUILD_ROOT/usr/sbin/iscsi_fw_login
rm -f $RPM_BUILD_ROOT/usr/sbin/iscsi_offload
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/iscsi-gen-initiatorname.8
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/iscsi_discovery.8
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/iscsi_fw_login.8
rm -f $RPM_BUILD_ROOT/var/lib/iscsi/ifaces/iface.example

install -d %{buildroot}%{_libexecdir}
install -pm 755 etc/systemd/iscsi-mark-root-nodes %{buildroot}%{_libexecdir}

install -d %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -pm 755 %{SOURCE1} %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d

install -d %{buildroot}%{_tmpfilesdir}
install -pm 644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/iscsi.conf

install -d %{buildroot}%{_libdir}
install -pm 755 libiscsi/libiscsi.so.0 %{buildroot}%{_libdir}
ln -s libiscsi.so.0 %{buildroot}%{_libdir}/libiscsi.so
install -d %{buildroot}%{_includedir}
install -pm 644 libiscsi/libiscsi.h %{buildroot}%{_includedir}

install -d %{buildroot}%{python3_sitearch}
pushd libiscsi
%py3_install
popd

%post
%systemd_post iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%preun
%systemd_preun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%postun
%systemd_postun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%post iscsiuio
%systemd_post iscsiuio.service iscsiuio.socket

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun iscsiuio
%systemd_postun iscsiuio.service iscsiuio.socket

%triggerun -- %{name} < 6.2.1.9-1
systemctl --no-reload preset iscsi.service iscsi-starter.service &>/dev/null || :

%files
%license COPYING
%doc README
%dir %{_sharedstatedir}/iscsi
%dir %{_sharedstatedir}/iscsi/nodes
%dir %{_sharedstatedir}/iscsi/isns
%dir %{_sharedstatedir}/iscsi/static
%dir %{_sharedstatedir}/iscsi/slp
%dir %{_sharedstatedir}/iscsi/ifaces
%dir %{_sharedstatedir}/iscsi/send_targets
%ghost %dir %attr(0700, root, root) %{_rundir}/lock/iscsi
%ghost %attr(0600, root, root) %{_rundir}/lock/iscsi/lock
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-starter.service
%{_unitdir}/iscsi-onboot.service
%{_unitdir}/iscsi-init.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_prefix}/lib/NetworkManager
%{_tmpfilesdir}/iscsi.conf
%dir %{_sysconfdir}/iscsi
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
%{_sbindir}/iscsi-iname
%{_sbindir}/iscsiadm
%{_sbindir}/iscsid
%{_sbindir}/iscsistart
%{_libdir}/libiscsi.so.0
%{_libdir}/libopeniscsiusr.so.*
%{_mandir}/man8/iscsi-iname.8.gz
%{_mandir}/man8/iscsiadm.8.gz
%{_mandir}/man8/iscsid.8.gz
%{_mandir}/man8/iscsistart.8.gz

%files iscsiuio
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_sbindir}/iscsiuio
%{_mandir}/man8/iscsiuio.8.gz

%files devel
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h
%{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_libdir}/pkgconfig/libopeniscsiusr.pc
%{_mandir}/man3/*

%files -n python3-%{name}
%{python3_sitearch}/*

%changelog
* Wed Jan 03 2024 Upgrade Robot <upbot@opencloudos.org> - 6.2.1.9-1
- Upgrade to version 6.2.1.9

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.2.1.4-5.git2a8f9d8
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 6.2.1.4-4.git2a8f9d8
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Jun 08 2023 kianli <kianli@tencent.com> - 6.2.1.4-3.git2a8f9d8
- Renumber use-opencloudos-as-default-iqn-name.patch

* Wed Jun 07 2023 kianli <kianli@tencent.com> - 6.2.1.4-2.git2a8f9d8
- use opencloudos as default iqn name

* Wed Nov 16 2022 Xiaojie Chen <jackxjchen@tencent.com> - 6.2.1.4-1.git2a8f9d8
- Initial build
